
import os
import glob
import subprocess
import time

assessment_dir = "C:\Gradle Integration Example\AltoroJ 3.1.1"
exec_ifa_str = "c:\\ifa\\wlp\\bin\\server start IFA"
healthcheck = 'java -jar ifa-client.jar -c'

# call IFA healthcheck
r = subprocess.Popen(healthcheck, stdout=subprocess.PIPE)
output = r.communicate()[0].decode("utf-8")

#check for error 
if output.find("error:") > -1:
    print('IFA Server may not be running, attempting to start IFA ')
    #attempt to start IFA server
    r = subprocess.Popen(exec_ifa_str, shell=True)
    print('...waiting for IFA to start...')
    r.wait()
    # call IFA healthcheck again
    print('...checking health again...')
    r = subprocess.Popen(healthcheck, stdout=subprocess.PIPE)
    output = r.communicate()[0].decode("utf-8")
    #exit if it didn't start this time
    if output.find("error:") > -1:
        print("Could not start IFA server, exiting")
        print 
        exit(-1)

# find the newest assessment file in the directory
newest = max(glob.iglob(os.path.join(assessment_dir, '*.ozasmt')), key=os.path.getctime)
print ('processing ' + newest)

# call IFA
exec_ifa_str = 'java -jar ifa-client.jar -i "' + newest + '"'
r = subprocess.Popen(exec_ifa_str)
r.communicate()

# IFA will drop the filtered assessment in the same directory, so look for the newest assessment again
newest = max(glob.iglob(os.path.join(assessment_dir, '*.ozasmt')), key=os.path.getmtime)
print ('IFA Filtered Assessment: ' + newest)

# create an AppScan Source CLI script that will publish the assessment to ASE  
file = open('srcclicmds.txt','w')
file.write('login https://appscanvm:9443/ase appscanvm\\administrator watchfire -acceptssl\n')
file.write('oaf "' + assessment_dir + '\Altoro311_Gradle_IFA.ozasmt"\n')
file.write('pase -aseapplication "AltoroJ 3.1.1 Automation" -name "Altoro311_Gradle"\n')
file.write('exit')
file.close()

subprocess.call('appscansrccli scr srcclicmds.txt')
#print('')
#print('Login to ASE:')
#print ('login https://appscanvm:9443/ase appscanvm\\administrator watchfire -acceptssl\n')
#print ('')
#print ('Publish scan results to ASE:')
#print ('pase -aseapplication "AltoroJ 3.1.1 Automation" "' + newest + '" -name "Altoro311_Gradle"\n')
